#!/bin/bash

# lendo linha a linha o arquivo com os numeros de serie e seguranca

while read n; do

   # extraindo o numero de seguranca da linha
   # formato da linha no arquivo: numero_de_serie;numero_de_seguranca

   NSEG=`echo $n |cut -d';' -f2`

   # assinando o numero de seguranca com a chave privada utilizando SHA256 e codificando em base64
   # obs1: utilizar o parametro -n no comando echo para NAO incluir uma quebra de linha junto da assinatura
   # obs2: foram removidas todas quebras de linha resultantes da base64
   # obs3: para retirar a senha da chave privada, utilizar o comando: openssl rsa -in fabricante.key -out fabricante_sem_senha.key

   NSEG_ASSINADO_BASE64=`echo -n $NSEG |openssl dgst -sha256 -sign /root/fabricante_sem_senha.key |openssl enc -base64 -e |tr -d "\n"`

   # exibindo a nova linha com a assinatura do numero de seguranca

   echo "${n};${NSEG_ASSINADO_BASE64}"

done </root/numeros_de_serie_e_seguranca.txt
